import React, { useState, useEffect } from "react";
import { Redirect, Switch } from "react-router";
import AuthRoute from "./AuthRoute";
import ProductForm from "./ProductForm";
import ProductGrid from "./ProductGrid";
import SearchResults from "./SearchResults";
import {getAllProducts} from "../actions/apiRequests.js"
import PromotionNewFormComponent from "./promotionforms/PromotionNewFormComponent";

export default function Main() {
  const [productData, setproductData] = useState([]);

  useEffect(() => {
    loadProducts();
  }, []);

  const loadProducts = async (event) => {
    const data = await getAllProducts();
    setproductData(data);
  };

  return (
    <div>
      <Switch>
        <AuthRoute exact path="/products/new">
          <ProductForm method="POST" />
        </AuthRoute>
        <AuthRoute exact path="/products/edit/:productId">
          <ProductForm method="PUT" />
        </AuthRoute>
        <AuthRoute
          exact
          path="/promos/new"
          component={PromotionNewFormComponent}
        ></AuthRoute>
        <AuthRoute exact path="/products" component={ProductGrid}></AuthRoute>
        <AuthRoute path="/promos">PROMOS</AuthRoute>
        <AuthRoute exact path="/">
          <Redirect to="/products" />
        </AuthRoute>
        <AuthRoute path="/searchResults" component={SearchResults}/>
        <AuthRoute>
          <h1>404 Page Not Found</h1>
        </AuthRoute>
      </Switch>
    </div>
  );
}
